#include <mysql/mysql.h>
#include  "stralloc.h"
#include "qsutil.h"

#define TRIES 3

/* let's alloc our strallocs */
extern stralloc DB_HOST;
extern stralloc DB_USER;
extern stralloc DB_PASS;
extern stralloc DB_NAME;
extern stralloc DB_SOCK;
extern stralloc DB_PORT;

extern MYSQL dbh, *mysql;
extern init_mysql();

int connect_mysql() {
  char *sock;
  int i, port;

  if (mysql && ! mysql_ping(&dbh)) return 1;
  if (init_mysql() == -1) return -1;
  if (DB_PORT.a > 0) port = atoi(DB_PORT.s);
  else port = 0;
  if (DB_SOCK.a > 0) sock = DB_SOCK.s;
  else sock = (char) 0;
  for (i = 0; i < TRIES; i++) {
    mysql = mysql_real_connect(&dbh, DB_HOST.s, DB_USER.s, DB_PASS.s, DB_NAME.s,
                               port, sock, 0);
    if (mysql) { 
#ifndef O_NOT_LOG_CONNECTS
      log3("connected to '", DB_NAME.s, "' database\n");
#endif
      break;
    }
    /* this is bad - we'll log it regardless */
    /* of the value of -DO_NOT_LOG           */
    log3("error: ", mysql_error(&dbh), "\n");
    sleep(3);
  }
  stralloc_free(&DB_HOST);
  stralloc_free(&DB_USER);
  stralloc_free(&DB_PASS);
  stralloc_free(&DB_NAME);
  stralloc_free(&DB_PORT);
  stralloc_free(&DB_SOCK);
  if (i < TRIES) return 1;
  else return 0;
}

void disconnect_mysql() {
  mysql_close(&dbh);
}
