#include "sig.h"
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "readwrite.h"
#include "stralloc.h"
#include "substdio.h"
#include "alloc.h"
#include "auto_qmail.h"
#include "control.h"
#include "received.h"
#include "constmap.h"
#include "error.h"
#include "ipme.h"
#include "ip.h"
#include "qmail.h"
#include "str.h"
#include "fmt.h"
#include "scan.h"
#include "byte.h"
#include "case.h"
#include "wait.h"
#include "env.h"
#include "now.h"
#include "exit.h"
#include "rcpthosts.h"
#include "timeoutread.h"
#include "timeoutwrite.h"
#include "commands.h"
#include "dns.h"

extern int connect_mysql();
extern void disconnect_mysql();
extern int rcpthosts_mysql(char *host, int len);

#define MAXHOPS 100
#define USE_SMTPAUTH
/* #define USE_OLD_GREETING */
#define USE_NEW_GREETING

unsigned int databytes = 0;
unsigned int nullsendermultrcpts = 0; 
int timeout = 1200;
stralloc qmail_mysql_query = { 0 };

/* SpaceNet - maex */
char strnum[FMT_ULONG];
char sserrbuf[512];
substdio sserr = SUBSTDIO_FDBUF(write,2,sserrbuf,sizeof(sserrbuf));
void logerr(s) char *s; { if(substdio_puts(&sserr,s) == -1) _exit(1); }
void logerrf(s) char *s; { if(substdio_puts(&sserr,s) == -1) _exit(1); if(substdio_flush(&sserr) == -1) _exit(1); }
void logerrpid() { strnum[fmt_ulong(strnum,getpid())] = 0; logerr("pid "); logerr(strnum); logerr(" from "); }

int safewrite(fd,buf,len) int fd; char *buf; int len;
{
  int r;
  r = timeoutwrite(timeout,fd,buf,len);
  if (r <= 0) _exit(1);
  return r;
}

char ssoutbuf[512];
substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);

void flush() { substdio_flush(&ssout); }
void out(s) char *s; { substdio_puts(&ssout,s); }

void die_read() { _exit(1); }
void die_alarm() { out("451 timeout (#4.4.2)\r\n"); flush(); _exit(1); }
void die_nomem() { out("421 out of memory (#4.3.0)\r\n"); flush(); _exit(1); }
void die_mysql() { out("421 who killed the MySQL server? (#4.3.0)\r\n"); flush(); _exit(1); }
void die_control() { out("421 unable to read controls (#4.3.0)\r\n"); flush(); _exit(1); }
void die_crash() { out("421 child crashed (#4.3.0)\r\n"); flush(); _exit(1); }
void die_fork() { out("421 unable to start checkpassword.\r\n"); flush(); _exit(1); }
void die_ipme() { out("421 unable to figure out my IP addresses (#4.3.0)\r\n"); flush(); _exit(1); }
void straynewline() { out("451 See http://pobox.com/~djb/docs/smtplf.html.\r\n"); flush(); _exit(1); }
void err_smf() { out("451 DNS temporary failure (#4.3.0)\r\n"); }
void err_size() { out("552 sorry, that message size exceeds my databytes limit (#5.3.4)\r\n"); }
void err_hmf(arg1,arg2) char *arg1,*arg2; {
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Non-existing DNS_MX: ");
  logerr("MAIL "); logerr(arg2); logerrf("\n");  
  out("552 sorry, your envelope sender domain must exist (#5.7.1)\r\n"); }
void err_nogateway(arg1,arg2,arg3) char *arg1,*arg2,*arg3; {
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Invalid RELAY client: "); 
  logerr("MAIL from: <"); logerr(arg2); logerr (">, RCPT "); logerr(arg3); logerrf("\n");  
  out("553 sorry, that domain isn't allowed to be relayed thru this MTA (#5.7.1)\r\n"); }
void err_bmf(arg1,arg2,arg3) char *arg1,*arg2,*arg3; {
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Invalid SENDER address: "); 
  logerr("MAIL from: <"); logerr(arg2); logerr (">, RCPT "); logerr(arg3); logerrf("\n");  
  out("554 sorry, your envelope sender is in my badmailfrom list (#5.7.1)\r\n");
  flush(); _exit(1); }
void err_rcp(arg1,arg2,arg3) char *arg1,*arg2,*arg3; { 
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Invalid RECIPIENT address: "); 
  logerr("MAIL from: <"); logerr(arg2); logerr (">, RCPT "); logerr(arg3); logerrf("\n");  
  out("555 sorry, your envelope recipient is in my badrcptto list (#5.7.1)\r\n"); 
  flush(); _exit(1); }
void err_nullsender(arg1,arg2) char *arg1,*arg2; {
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Invalid NULLSENDER Mail: ");
  logerr ("Last RCPT "); logerr(arg2); logerrf("\n");  
  out("556 sorry, bounce messages should have a single envelope recipient (#5.7.1)\r\n"); 
  flush(); _exit(1); }
void err_bhs(arg1,arg2) char *arg1,*arg2; {
  logerr("qmail-smtpd: "); logerrpid(); logerr(arg1); logerr(" Blackholed SENDER address: "); 
  logerr("MAIL "); logerr(arg2); logerrf("\n");  
  flush(); _exit(1); }
void err_unimpl() { out("502 unimplemented (#5.5.1)\r\n"); }
void err_syntax() { out("555 syntax error (#5.5.4)\r\n"); }
void err_wantmail() { out("503 MAIL first (#5.5.1)\r\n"); }
void err_wantrcpt() { out("503 RCPT first (#5.5.1)\r\n"); }
void err_noop() { out("250 ok\r\n"); }
void err_vrfy() { out("252 send some mail, i'll try my best\r\n"); }
void err_qqt() { out("451 qqt failure (#4.3.0)\r\n"); }


stralloc greeting = {0};

void smtp_greet(code) char *code;
{
  substdio_puts(&ssout,code);
  substdio_put(&ssout,greeting.s,greeting.len);
}
void smtp_help()
{
  out("214 qmail home page: http://pobox.com/~djb/qmail.html\r\n");
}
void smtp_quit()
{
  disconnect_mysql();
  smtp_greet("221 "); out("\r\n"); flush(); _exit(0);
}

char *remoteip;
char *remotehost;
char *remoteinfo;
char *local;
char *relayclient;
char *nodnscheck;
char *msgsize;

stralloc helohost = {0};
char *fakehelo; /* pointer into helohost, or 0 */

void dohelo(arg) char *arg; {
  if (!stralloc_copys(&helohost,arg)) die_nomem();
  if (!stralloc_0(&helohost)) die_nomem();
  fakehelo = case_diffs(remotehost,helohost.s) ? helohost.s : 0;
}

int liphostok = 0;
stralloc liphost = {0};
int bmfok = 0;
stralloc bmf = {0};
struct constmap mapbmf;

/* Wildmat Variables */
int bmpok = 0;
stralloc bmp = {0};
struct constmap mapbmp;
/* Wildmat Patch  END */

/* RECIPIENT Check Variables */
int rcpok = 0;
stralloc rcp = {0};
struct constmap maprcp;
int brpok = 0;
stralloc brp = {0};
struct constmap mapbrp;

/* RELAYCLIENT Check Variables */
int relayclientsok = 0;
stralloc relayclients = {0};
struct constmap maprelayclients;
int relaydomainsok = 0;
stralloc relaydomains = {0};
struct constmap maprelaydomains;

/* RELAYMAILFROM Check Variables */
int rmfok = 0;
stralloc rmf = {0};
struct constmap maprmf;

/* TARPIT Check Variables */
int tarpitcount = 0;
int tarpitdelay = 5;

/* NODNSCHECK Check Variables */
int nodnschecksok = 0;
stralloc nodnschecks = {0};
struct constmap mapnodnschecks;

/* BLACKHOLE Sender Check Variables */
int bhsok = 0;
stralloc bhs = {0};
struct constmap mapbhs;

/* NULLSENDERMULTRCPTS Check Variable */
int nullsendermaxrcpts = 1;   /* Default value: only one RCPT for Null-Sender Mail */

void setup()
{
  char *x;
  unsigned long u;
  unsigned int i;
  unsigned len;
 
  if (control_init() == -1) die_control();
  if (control_rldef(&greeting,"control/smtpgreeting",1,(char *) 0) != 1)
    die_control();
  liphostok = control_rldef(&liphost,"control/localiphost",1,(char *) 0);
  if (liphostok == -1) die_control();
  if (control_readint(&timeout,"control/timeoutsmtpd") == -1) die_control();
  if (timeout <= 0) timeout = 1;

/* TARPIT Patch - include Control Files */
 
  if (control_readint(&tarpitcount,"control/tarpitcount") == -1) die_control();
  if (tarpitcount < 0) tarpitcount = 0;
  x = env_get("TARPITCOUNT");
  if (x) { scan_ulong(x,&u); tarpitcount = u; };
  if (control_readint(&tarpitdelay,"control/tarpitdelay") == -1) die_control();
  if (tarpitdelay < 0) tarpitdelay = 0;
  x = env_get("TARPITDELAY");
  if (x) { scan_ulong(x,&u); tarpitdelay = u; };

  if (rcpthosts_init() == -1) die_control();

  bmfok = control_readfile(&bmf,"control/badmailfrom",0);
  if (bmfok == -1) die_control();
  if (bmfok)
    if (!constmap_init(&mapbmf,bmf.s,bmf.len,0)) die_nomem();

/* RELAYMAILFROM Patch - include Control File */

  rmfok = control_readfile(&rmf,"control/relaymailfrom",0);
  if (rmfok == -1) die_control();
  if (rmfok)
    if (!constmap_init(&maprmf,rmf.s,rmf.len,0)) die_nomem();

/* Wildmat Patch - include Control file */ 
 
  bmpok = control_readfile(&bmp,"control/badmailpatterns",0);
  if (bmpok == -1) die_control();
  if (bmpok)
    if (!constmap_init(&mapbmp,bmp.s,bmp.len,0)) die_nomem();
 
/* RECIPIENT Patch - include Control file */

  rcpok = control_readfile(&rcp,"control/badrcptto",0);
  if (rcpok == -1) die_control();
  if (rcpok)
    if (!constmap_init(&maprcp,rcp.s,rcp.len,0)) die_nomem();

  brpok = control_readfile(&brp,"control/badrcptpatterns",0);
  if (brpok == -1) die_control();
  if (brpok)
    if (!constmap_init(&mapbrp,brp.s,brp.len,0)) die_nomem();

/* BLACKHOLE Sender Patch - include Control file */

  bhsok = control_readfile(&bhs,"control/blackholedsender",0);
  if (bhsok == -1) die_control();
  if (bhsok)
    if (!constmap_init(&mapbhs,bhs.s,bhs.len,0)) die_nomem();
  
  if (control_readint(&databytes,"control/databytes") == -1) die_control();
  x = env_get("DATABYTES");
  if (x) { scan_ulong(x,&u); databytes = u; }
  if (!(databytes + 1)) --databytes;

/* NULLSENDERMULTRCPTS from environment */

  x = env_get("NULLSENDERMULTRCPTS");
  if (x) { 
    scan_ulong(x,&u); nullsendermaxrcpts = u; 
    nullsendermultrcpts = nullsendermaxrcpts; } /* Customized # RCPTS for Null-Sender Mail */
  else { 
    nullsendermultrcpts = 0; /* Any number of RCTPS allowed */
  }
  if (!(nullsendermaxrcpts + 1)) --nullsendermaxrcpts;
 
  remoteip = env_get("TCPREMOTEIP");
  if (!remoteip) remoteip = "unknown";
  local = env_get("TCPLOCALHOST");
  if (!local) local = env_get("TCPLOCALIP");
  if (!local) local = "unknown";
  remotehost = env_get("TCPREMOTEHOST");
  if (!remotehost) remotehost = "unknown";
  remoteinfo = env_get("TCPREMOTEINFO");
  relayclient = env_get("RELAYCLIENT");

/* DNSCHECK Patch - include Control file */

  nodnscheck = env_get("NODNSCHECK");

  if (! nodnscheck) 
    {
      /* Look up "MAIL from:" addresses to skip for DNS check in control/nodnscheck. */
      nodnschecksok = control_readfile(&nodnschecks,"control/nodnscheck",0);
      if (nodnschecksok == -1) die_control();
      if (nodnschecksok)
	  if (!constmap_init (&mapnodnschecks, nodnschecks.s, nodnschecks.len, 0)) die_nomem();
    }

  if (! relayclient)
    {
      /* Attempt to look up the IP number in control/relayclients. */
      relayclientsok = control_readfile(&relayclients,"control/relayclients",0);
      if (relayclientsok == -1) die_control();
      if (relayclientsok) {
        if (!constmap_init (&maprelayclients, relayclients.s, relayclients.len, 1)) die_nomem();

        for (i = len = str_len (remoteip); i > 0; i --)
	  if ((i == len) || (remoteip[i - 1] == '.')) {
	    if ((relayclient = constmap (&maprelayclients, remoteip, i)))
      	      break;
	  }
       }
    }

  if (! relayclient)
    {
      /* Attempt to look up the host name in control/relaydomains. */
      relaydomainsok = control_readfile(&relaydomains,"control/relaydomains",0);
      if (relaydomainsok == -1) die_control();
      if (relaydomainsok) {
        if (!constmap_init (&maprelaydomains, relaydomains.s, relaydomains.len, 1)) die_nomem();

      	for (i = 0, len = str_len (remotehost); i <= len; i ++)
      	  if ((i == 0) || (i == len) || (remotehost[i] == '.'))
      	    if ((relayclient = constmap (&maprelaydomains, remotehost + i, len - i)))
      	      break;
      }
    }

  dohelo(remotehost);
}


stralloc addr = {0}; /* will be 0-terminated, if addrparse returns 1 */

int addrparse(arg)
char *arg;
{
  int i;
  char ch;
  char terminator;
  struct ip_address ip;
  int flagesc;
  int flagquoted;

  terminator = '>';
  i = str_chr(arg,'<');
  if (arg[i])
    arg += i + 1;
  else { /* partner should go read rfc 821 */
    terminator = ' ';
    arg += str_chr(arg,':');
    if (*arg == ':') ++arg;
    while (*arg == ' ') ++arg;
  }

  /* strip source route */
  if (*arg == '@') while (*arg) if (*arg++ == ':') break;

  if (!stralloc_copys(&addr,"")) die_nomem();
  flagesc = 0;
  flagquoted = 0;
  for (i = 0;ch = arg[i];++i) { /* copy arg to addr, stripping quotes */
    if (flagesc) {
      if (!stralloc_append(&addr,&ch)) die_nomem();
      flagesc = 0;
    }
    else {
      if (!flagquoted && (ch == terminator)) break;
      switch(ch) {
        case '\\': flagesc = 1; break;
        case '"': flagquoted = !flagquoted; break;
        default: if (!stralloc_append(&addr,&ch)) die_nomem();
      }
    }
  }
  /* could check for termination failure here, but why bother? */
  if (!stralloc_append(&addr,"")) die_nomem();

  if (liphostok) {
    i = byte_rchr(addr.s,addr.len,'@');
    if (i < addr.len) /* if not, partner should go read rfc 821 */
      if (addr.s[i + 1] == '[')
        if (!addr.s[i + 1 + ip_scanbracket(addr.s + i + 1,&ip)])
          if (ipme_is(&ip)) {
            addr.len = i + 1;
            if (!stralloc_cat(&addr,&liphost)) die_nomem();
            if (!stralloc_0(&addr)) die_nomem();
          }
  }

  if (addr.len > 900) return 0;
  return 1;
}

/* SIZELIMIT Function by Chris Harris */

int sizelimit(arg)
 char *arg;
 {
   int i;
   long r;
   unsigned long sizebytes = 0; 
 
   i = str_chr(arg,'<');
   if (arg[i])
     arg += i + 1;
   else {
     arg += str_chr(arg,':');
     if (*arg == ':') ++arg;
     while (*arg == ' ') ++arg;
   }
 
   arg += str_chr(arg,' ');
   if (*arg == ' ') while (*arg == ' ') ++arg;
   else return 1;
 
   i = str_chr(arg,'=');
   arg[i] = 0;
   if (case_equals(arg,"SIZE")) {
     arg += i;
     while (*++arg && *arg > 47 && *arg < 58) {
       sizebytes *= 10;
       sizebytes += *arg - 48;
     }
     r = databytes - sizebytes;
     if (r < 0) return 0;
   }
   return 1;
 }

int bmfcheck()
{
  int i;
  int j;
  int k = 0;
  char subvalue;

  if (bmfok) {
  if (constmap(&mapbmf,addr.s,addr.len - 1)) return 1;
  j = byte_rchr(addr.s,addr.len,'@');
  if (j < addr.len)
    if (constmap(&mapbmf,addr.s + j,addr.len - j - 1)) return 1;
  }

/* Include control file control/badmailpatterns and evaluate with Wildmat check */
     
  if (bmpok) {
  i = 0;
  for (j = 0;j < bmp.len;++j)
   if (!bmp.s[j]) {
    subvalue = bmp.s[i] != '!';
    if (!subvalue) i++;
    if ((k != subvalue) && wildmat(addr.s, bmp.s + i)) k = subvalue;
    i = j + 1;
    }
   return k;
  }
  return 0;
}

/* Check on "black holed" senders */

int bhscheck()
{
  int j;

  if (bhsok) {
  if (constmap(&mapbhs,addr.s,addr.len - 1)) return 1;
  j = byte_rchr(addr.s,addr.len,'@');
  if (j < addr.len)
    if (constmap(&mapbhs,addr.s + j,addr.len - j - 1)) return 1;
  }
  return 0;
}


int rmfcheck()
{
  int j;
  if (!rmfok) return 0;
  if (constmap(&maprmf,addr.s,addr.len - 1)) return 1;
  j = byte_rchr(addr.s,addr.len,'@');
  if (j < addr.len)
    if (constmap(&maprmf,addr.s + j,addr.len - j - 1)) return 1;
  return 0;
}

int rcpcheck()
{
  int i;
  int j;
  int k = 0;
  char subvalue;

/* Include control file control/badrcptto */

  if (rcpok) {
  if (constmap(&maprcp,addr.s,addr.len - 1)) return 1;
  j = byte_rchr(addr.s,addr.len,'@');
  if (j < addr.len)
    if (constmap(&maprcp,addr.s + j,addr.len - j - 1)) {
      return 1;
    }  
  }

/* Include control file control/badrcptpatterns and evaluate with Wildmat check */

  if (brpok) {
  i = 0;
  for (j = 0;j < brp.len;++j)
   if (!brp.s[j]) {
    subvalue = brp.s[i] != '!';
    if (!subvalue) i++;
    if ((k != subvalue) && wildmat(addr.s, brp.s + i)) k = subvalue;
    i = j + 1;
    }
   return k;
  }
  return 0;
}

int dnscheck()
{
  stralloc sa = {0};
  ipalloc ia = {0};
  unsigned int random;
  int j;

  if (nodnschecksok) {
  if (constmap(&mapnodnschecks,addr.s,addr.len - 1)) return 0;
  j = byte_rchr(addr.s,addr.len,'@');
  if (j < addr.len)
    if (constmap(&mapnodnschecks,addr.s + j,addr.len - j - 1)) return 0;
  }

  random = now() + (getpid() << 16);
  j = byte_rchr(addr.s,addr.len,'@') + 1;
  if (j < addr.len) {
    stralloc_copys(&sa, addr.s + j);
    dns_init(0);
    j = dns_mxip(&ia,&sa,random);
    if (j < 0) return j;
  }
  return 0;
}

int addrallowed()
{
  int r;
  r = rcpthosts(addr.s,str_len(addr.s));
  if (r == -1) die_control();
  if (! r) r = rcpthosts_mysql(addr.s,str_len(addr.s));
  if (r == -1) die_control();
  return r;
}


int seenmail = 0;
int rcptcount; /* defined if seenmail */
int flagbarf; /* defined if seenmail */
int flagrcpt; /* recipient filter   */
int flagbhs;  /* blackholed sender */
stralloc mailfrom = {0};
stralloc rcptto = {0};
char size_buf[FMT_ULONG]; /* needed for SIZE CMD */  

void smtp_helo(arg) char *arg;
{
    smtp_greet("250 "); out("\r\n");
    seenmail = 0; dohelo(arg);
}
void smtp_size()
{
   size_buf[fmt_ulong(size_buf,(unsigned long) databytes)] = 0;
   out("250 SIZE "); out(size_buf); out("\r\n");
}
void smtp_ehlo(arg) char *arg;
{
  /*smtp_size();*/
  smtp_greet("250-");
  #ifdef USE_SMTPAUTH
  #ifdef USE_OLD_GREETING
   out("\r\n250-AUTH=LOGIN CRAM-MD5 PLAIN");
  #endif
  #ifdef USE_NEW_GREETING
    out("\r\n250-AUTH LOGIN CRAM-MD5 PLAIN");
  #endif
  #endif
 
  out("\r\n250-PIPELINING\r\n250 8BITMIME\r\n");
  seenmail = 0; dohelo(arg);
}
void smtp_rset()
{
  seenmail = 0;
  out("250 flushed\r\n");
}
void smtp_mail(arg) char *arg;
{
  if (!addrparse(arg)) { err_syntax(); return; }
/* Return error if incoming SMTP msg exceeds DATABYTES */
  if (databytes && !sizelimit(arg)) { err_size(); return; }
/* Terminate SMTP Session immediatly if BLACKHOLED Sender is seen */
  if (bhscheck()) { err_bhs(remoteip,arg); return; }
  if (!relayclient) { if (rmfcheck()) relayclient = ""; else relayclient = 0; } /* We redefine relayclient */
  if (!relayclient) { flagbarf = bmfcheck(); } /* We check bad SENDERS only in non-RELAYCLIENT case */
  if (!nodnscheck) {
    switch(dnscheck()) {
      case DNS_HARD: err_hmf(remoteip,arg); return;
      case DNS_SOFT: err_smf(); return;
      case DNS_MEM: die_nomem(); }
  }
  seenmail = 1;
  if (!stralloc_copys(&rcptto,"")) die_nomem();
  if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
  if (!stralloc_0(&mailfrom)) die_nomem();
  rcptcount = 0;
  out("250 ok\r\n");
}
void smtp_rcpt(arg) char *arg; 
{
  if (!seenmail) { err_wantmail(); return; }
  if (!addrparse(arg)) { err_syntax(); return; }
  flagrcpt = rcpcheck(); 
  if (flagbarf) { err_bmf(remoteip,mailfrom.s,arg); return; }
  if (relayclient) {
    --addr.len;
    if (!stralloc_cats(&addr,relayclient)) die_nomem();
    if (!stralloc_0(&addr)) die_nomem();
  }
  else
    if (!addrallowed()) { err_nogateway(remoteip,mailfrom.s,arg); return; } 
  if (!stralloc_cats(&rcptto,"T")) die_nomem();
  if (!stralloc_cats(&rcptto,addr.s)) die_nomem();
  if (!stralloc_0(&rcptto)) die_nomem();
  if (flagrcpt) { err_rcp(remoteip,mailfrom.s,arg); return; } /* RECIPIENT BAD* check */
  rcptcount++;
  if ( nullsendermultrcpts != 0 ) { /* Null-Sender Check on # RCPTS */
    if ( mailfrom.len == 1 && rcptcount > nullsendermaxrcpts ) { err_nullsender(remoteip,arg); return; } }
  if (tarpitcount && rcptcount >= tarpitcount) while (sleep(tarpitdelay)); /* TARPIT Delay */
  out("250 ok\r\n");
}


int saferead(fd,buf,len) int fd; char *buf; int len;
{
  int r;
  flush();
  r = timeoutread(timeout,fd,buf,len);
  if (r == -1) if (errno == error_timeout) die_alarm();
  if (r <= 0) die_read();
  return r;
}

char ssinbuf[1024];
substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);

struct qmail qqt;
unsigned int bytestooverflow = 0;

void put(ch)
char *ch;
{
  if (bytestooverflow)
    if (!--bytestooverflow)
      qmail_fail(&qqt);
  qmail_put(&qqt,ch,1);
}

void blast(hops)
int *hops;
{
  char ch;
  int state;
  int flaginheader;
  int pos; /* number of bytes since most recent \n, if fih */
  int flagmaybex; /* 1 if this line might match RECEIVED, if fih */
  int flagmaybey; /* 1 if this line might match \r\n, if fih */
  int flagmaybez; /* 1 if this line might match DELIVERED, if fih */
  int seencr;   
 
  state = 1;
  *hops = 0;
  flaginheader = 1;
  pos = 0; flagmaybex = flagmaybey = flagmaybez = 1; seencr = 0; /* qmail-smtpd-newline patch */
   for (;;) {
    substdio_get(&ssin,&ch,1);
    if (ch == '\n')
     {
      if (seencr == 0)
       {
        substdio_seek(ssin,-1);
        ch = '\r';
       }
     }
    if (ch == '\r') seencr = 1; else seencr = 0;
    if (flaginheader) {
      if (pos < 9) {
        if (ch != "delivered"[pos]) if (ch != "DELIVERED"[pos]) flagmaybez = 0;
        if (flagmaybez) if (pos == 8) ++*hops;
        if (pos < 8)
          if (ch != "received"[pos]) if (ch != "RECEIVED"[pos]) flagmaybex = 0;
        if (flagmaybex) if (pos == 7) ++*hops;
        if (pos < 2) if (ch != "\r\n"[pos]) flagmaybey = 0;
        if (flagmaybey) if (pos == 1) flaginheader = 0;
      }
      ++pos;
      if (ch == '\n') { pos = 0; flagmaybex = flagmaybey = flagmaybez = 1; }
    }
    switch(state) {
      case 0:
        if (ch == '\n') straynewline();
        if (ch == '\r') { state = 4; continue; }
        break;
      case 1: /* \r\n */
        if (ch == '\n') straynewline();
        if (ch == '.') { state = 2; continue; }
        if (ch == '\r') { state = 4; continue; }
        state = 0;
        break;
      case 2: /* \r\n + . */
        if (ch == '\n') straynewline();
        if (ch == '\r') { state = 3; continue; }
        state = 0;
        break;
      case 3: /* \r\n + .\r */
        if (ch == '\n') return;
        put(".");
        put("\r");
        if (ch == '\r') { state = 4; continue; }
        state = 0;
        break;
      case 4: /* + \r */
        if (ch == '\n') { state = 1; break; }
        if (ch != '\r') { put("\r"); state = 0; }
    }
    put(&ch);
  }
}

char accept_buf[FMT_ULONG];
void acceptmessage(qp) unsigned long qp;
{
  datetime_sec when;
  when = now();
  out("250 ok ");
  accept_buf[fmt_ulong(accept_buf,(unsigned long) when)] = 0;
  out(accept_buf);
  out(" qp ");
  accept_buf[fmt_ulong(accept_buf,qp)] = 0;
  out(accept_buf);
  out("\r\n");
}

void smtp_data() {
  int hops;
  unsigned long qp;
  char *qqx;

  if (!seenmail) { err_wantmail(); return; }
  if (!rcptto.len) { err_wantrcpt(); return; }
  seenmail = 0;
  if (databytes) bytestooverflow = databytes + 1;
  if (qmail_open(&qqt) == -1) { err_qqt(); return; }
  qp = qmail_qp(&qqt);
  out("354 go ahead\r\n");

  received(&qqt,"SMTP",local,remoteip,remotehost,remoteinfo,fakehelo);
  blast(&hops);
  hops = (hops >= MAXHOPS);
  if (hops) qmail_fail(&qqt);
  qmail_from(&qqt,mailfrom.s);
  qmail_put(&qqt,rcptto.s,rcptto.len);

  qqx = qmail_close(&qqt);
  if (!*qqx) { acceptmessage(qp); return; }
  if (hops) { out("554 too many hops, this message is looping (#5.4.6)\r\n"); return; }
  if (databytes) if (!bytestooverflow) { err_size(); return; } 
  if (*qqx == 'D') out("554 "); else out("451 ");
  out(qqx + 1);
  out("\r\n");
}

#ifdef USE_SMTPAUTH
static unsigned char authenticated=0;
static unsigned char *base64_alphabet =
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
static int unbase64(ch) int ch; {
  int i;
  if (ch == '=') return 0;
  for (i = 0; i < 64; i++)
    if (ch == base64_alphabet[i])
      return i;
  return 0;
}
static int base64_dec_buffer(str,dst,len) const char *str;void *dst;int len;
{
  int i, j, l;
  unsigned char input[4], output[3], *result = (char *)dst;
  if (str == 0)
    return 0;
  l = str_len(str);
  if (dst == 0 || l > len)
    return (l / 4) * 3;
  memset(dst,0,len);
  for (i=j=0; i<l; i +=4) {
    input[0] = unbase64(str[i]);
    input[1] = unbase64(str[i+1]);
    input[2] = unbase64(str[i+2]);
    input[3] = unbase64(str[i+3]);
    output[0] = (input[0] << 2) | (input[1] >> 4);
    output[1] = (input[1] << 4) | (input[2] >> 2);
    output[2] = (input[2] << 6) | (input[3]);
    result[j] = output[0];
    if (str[i+1] == '=') return j+1;
    result[j+1]=output[1];
    if (str[i+2] == '=') return j+2;
    result[j+2]=output[2];
    j += 3;
  }
  return j;
}
static char **smtpauth_argv;
static char *auth_argv[4];
static stralloc smtpauth = {0};
static char smtpauthlogin[65];
static char smtpauthpass[65];
static char smtpauthtimestamp[65];

char unique[FMT_ULONG + FMT_ULONG + 3];

void base64encode(stralloc *input, stralloc *output)
{
int	a=0,b=0,c=0;
int	i, j;
int	d, e, f, g;

	if (input->len == 0)	return;

	for (j=i=0; i< input->len ; i += 3)
	{
		a=input->s[i];
		b= i+1 < input->len ? input->s[i+1]:0;
		c= i+2 < input->len ? input->s[i+2]:0;

		d=base64_alphabet[ a >> 2 ];
		e=base64_alphabet[ ((a & 3 ) << 4) | (b >> 4)];
		f=base64_alphabet[ ((b & 15) << 2) | (c >> 6)];
		g=base64_alphabet[ c & 63 ];
		if (i + 1 >= input->len) f='=';
		if (i + 2 >= input->len) g='=';
		stralloc_append(output,&d);
		stralloc_append(output,&e);
		stralloc_append(output,&f);
		stralloc_append(output,&g);
	}
}

static int smtpauth_getl(void) {
  int i;
  if (!stralloc_copys(&smtpauth, "")) return -1;
  for (;;) {
    if (!stralloc_readyplus(&smtpauth,1)) return -1;
    i = substdio_get(&ssin, smtpauth.s + smtpauth.len, 1);
    if (i != 1) return i;
    if (smtpauth.s[smtpauth.len] == '\n') break;
    ++smtpauth.len;
  }
  if (smtpauth.len > 0) if (smtpauth.s[smtpauth.len-1] == '\r') --smtpauth.len;
  smtpauth.s[smtpauth.len] = 0;
  return smtpauth.len;
}

static void smtpauth_authenticate(void)
{
  int st, pid, fds[2];
  
    if (pipe(fds)) {
      out("535 pipe failure\r\n");
      flush();
      _exit(0);
    }
    /* spawn external program

    external program should return '0' if it was successful,

    submit: /bin/checkpassword /bin/true
  
    */
    switch ((pid=fork())) {
      case -1: die_fork();
      case 0: close(fds[1]);
        fd_copy(3,fds[0]);
        flush();
        execvp(auth_argv[1], auth_argv+1);
        die_nomem();
    };
    close(fds[0]);
    write(fds[1], smtpauthlogin, str_len(smtpauthlogin)+1);
    write(fds[1], smtpauthpass, str_len(smtpauthpass)+1);
    if (str_len(smtpauthtimestamp))
    {
          write(fds[1], smtpauthtimestamp, str_len(smtpauthtimestamp)+1);
    }
    close(fds[1]);
    wait_pid(&st, pid);

    if (wait_crashed(st))
      die_crash();
    if (wait_exitcode(st) == 0) {
      out("235 go ahead\r\n");
      flush();
      relayclient="";
      authenticated=1;
      return;
    }
    sleep(2);
    out("535 auth failure\r\n"); 
    flush(); 
    return;
}

void smtp_auth(arg) char *arg; {
  int ret,i,toolong,start;
  char *helper;
  /* netscape 4.5 sends AUTH LOGIN <base64encodedusername>
     microsoft outlook express sends AUTH LOGIN

     idea is simple

     use an external program to test authority
     if success, set 'RELAYCLIENT'
     otherwise, let them know nicely (hangup)

     note, i really don't like djb's coding style even though i'm using it here.
     i think using spaces for tabs is bad.
                                                -mrs.brisby@nimh.org
  */
  /* Here i've added support for other auth types.
  
  						-brush@elysium.pl	*/
  if (!authenticated)
  {
    if ((ret=strncasecmp(arg,"login",5))==0)
    {
      while (arg && *arg && *arg != ' ') arg++;

      /* pass over the space */
      while (arg && *arg && *arg == ' ') arg++;

      if (arg && *arg) {
        /* here's the base64 encoded login */
        base64_dec_buffer(arg, smtpauthlogin, sizeof(smtpauthlogin));
      } else {
        out("334 VXNlcm5hbWU6\r\n"); /* b64 <- 'Username:' */
        flush();
        if (smtpauth_getl() > 0)
          base64_dec_buffer(smtpauth.s, smtpauthlogin, sizeof(smtpauthlogin));
        else
          die_read();
      }
      out("334 UGFzc3dvcmQ6\r\n"); /* b64 <- 'Password:' */
      flush();
      if (smtpauth_getl() > 0)
        base64_dec_buffer(smtpauth.s, smtpauthpass, sizeof(smtpauthpass));
      else
        die_read();
      smtpauthtimestamp[0]=0;
      auth_argv[1]=smtpauth_argv[1];	/* change checkpass prg */
      auth_argv[2]=smtpauth_argv[2];	/* change checkpass prg */
      auth_argv[3]=NULL;			/* change checkpass prg */
      smtpauth_authenticate();  
      return;
    }
    else if ((ret=strncasecmp(arg,"plain",5))==0)
    {
      static char smtpauthloginpass[200];

      while (arg && *arg && *arg != ' ') arg++;

      /* pass over the space */
      while (arg && *arg && *arg == ' ') arg++;
 
      if (arg && *arg)
      {
        if(strlen(arg)*3/4 >= sizeof(smtpauthloginpass))
        {
          out("535 input too long\r\n");
          flush();
          return;
        }
        /* here's the base64 encoded login/password */
        base64_dec_buffer(arg, smtpauthloginpass, sizeof(smtpauthloginpass)-1);
      } else {
        out("334 ok. go on.\r\n");
        flush();
        i=smtpauth_getl();
        if(i <= 0)
          die_read();
        else if(i*3/4 >= sizeof(smtpauthloginpass))
        {
          out("535 input too long\r\n");
          flush();
          return;
        } else base64_dec_buffer(smtpauth.s, smtpauthloginpass, sizeof(smtpauthloginpass)-1);
      }
      smtpauthloginpass[sizeof(smtpauthloginpass)-1]=0;
      start=strlen(smtpauthloginpass)+1;
      if((start >= sizeof(smtpauthloginpass)) || (strlen(smtpauthloginpass+start) >= 65))
      {
          out("535 malformed input\r\n");
          flush();
          return;
      }
      strcpy(smtpauthlogin,smtpauthloginpass+start);

      start+=strlen(smtpauthlogin)+1;
      if((start >= sizeof(smtpauthloginpass)) || (strlen(smtpauthloginpass+start) >= 65))
      {
          out("535 malformed input\r\n");
          flush();
          return;
      }
      strcpy(smtpauthpass,smtpauthloginpass+start);

      smtpauthtimestamp[0]=0;
      auth_argv[1]=smtpauth_argv[1];	/* change checkpass prg */
      auth_argv[2]=smtpauth_argv[2];	/* change checkpass prg */
      auth_argv[3]=NULL;		/* change checkpass prg */
      smtpauth_authenticate();
      return;
    }
    else if ((ret=strncasecmp(arg,"cram-md5",8))==0)  
    {
      int r;
      static stralloc me = {0};
      static stralloc greet = {0};
      static stralloc greetenc = {0};
      char *s;
      r = control_readline(&me,"control/me");
      if (r != 1) 
      {
        out("535 internal server error\r\n"); flush(); _exit(0);
      }
      for (r=0;r <= me.len;r++)
      {
        if (me.s[r]=='\n')
        {
          me.s[r]=0;
          break;
        }
      }

      s = unique;
      s += fmt_uint(s,getpid());
      *s++ = '.';
      s += fmt_ulong(s,(unsigned long) now());
      *s++ = '@';
      *s++ = 0;
      if (greet.len)
      {
	for (i=0;i<greet.len;i++)
	{
	  greet.s[i]=0;
	}
        greet.len=0;
      }
      stralloc_append(&greet,"<");
      stralloc_cats(&greet,unique);
      stralloc_cats(&greet,me.s);
      stralloc_cats(&greet,">");
      greet.s[greet.len]=0;	// obscure fix but it works
      stralloc_readyplus(&greet,3);
      if (greetenc.len)
      {
	for (i=0;i<greetenc.len;i++)
	{
	  greetenc.s[i]=0;
	}
        greetenc.len=0;
      }
      flush();
      base64encode(&greet,&greetenc);
      greetenc.s[greetenc.len]=0;	// obscure fix but it works
      out("334 ");
      out(greetenc.s);
      out("\r\n");
      flush();
      if (smtpauth_getl() > 0)
      {
        s=calloc((size_t) strlen(smtpauth.s),(size_t)1);
        base64_dec_buffer(smtpauth.s, s, strlen(smtpauth.s));
      }
      helper=strtok(s," ");
      if(helper!=NULL)
      {
        strncpy (smtpauthlogin,helper,64);
      }
      else
      {
        out("535 malformed input\r\n"); 
        return;
      }
      helper=strtok(NULL," ");
      if(helper!=NULL)
      {
        strncpy (smtpauthtimestamp,helper,64);
      }
      else
      {
        out("535 malformed input\r\n"); 
        return;
      }
      strncpy (smtpauthpass,greet.s,64);
      auth_argv[1]=smtpauth_argv[3];	/* change checkpass prg */
      auth_argv[2]=smtpauth_argv[4];	/* change checkpass prg */
      auth_argv[3]=NULL;		/* change checkpass prg */
      smtpauth_authenticate();
      return;
    }
    else
    {
      out("504 auth type not supported\r\n"); 
      flush();
      return;
    }
  }
  else
  {
      out("503 you are already authenticated\r\n"); 
      flush(); 
      return;
  }
}
#endif

struct commands smtpcommands[] = {
  { "rcpt", smtp_rcpt, 0 }
, { "mail", smtp_mail, 0 }
, { "data", smtp_data, flush }
#ifdef USE_SMTPAUTH
, { "auth", smtp_auth, flush }
#endif
, { "quit", smtp_quit, flush }
, { "helo", smtp_helo, flush }
, { "ehlo", smtp_ehlo, flush }
, { "rset", smtp_rset, 0 }
, { "help", smtp_help, flush }
, { "noop", err_noop, flush }
, { "vrfy", err_vrfy, flush }
, { 0, err_unimpl, flush }
} ;

void main(argc,argv) int argc; char **argv;
{
#ifdef USE_SMTPAUTH
  smtpauth_argv = argv;
#endif
  sig_pipeignore();
  if (! connect_mysql()) die_mysql();
  if (chdir(auto_qmail) == -1) die_control();
  setup();
  if (ipme_init() != 1) die_ipme();
  smtp_greet("220 ");
  out(" ESMTP\r\n");
  if (commands(&ssin,&smtpcommands) == 0) die_read();
  die_nomem();
}
